#ifndef __BEOSSPRITE_H__
#define __BEOSSPRITE_H__

#include "beosdefs.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __BEOSSPRITE_CPP__
    #define EXTERN
#else
    #define EXTERN extern
#endif

EXTERN W_Font W_BigFont;
EXTERN W_Font W_RegularFont;

EXTERN int W_Textwidth;
EXTERN int W_Textheight;
EXTERN int W_BigTextwidth;
EXTERN int W_BigTextheight;

#ifdef __BEOSSPRITE_CPP__
    W_Color W_White = {0xff, 0xff, 0xff};
    W_Color W_Black = {0x00, 0x00, 0x00};
    W_Color W_Red = {0xff, 0x00, 0x00};
    W_Color W_Green = {0x00, 0xff, 0x00};
    W_Color W_Yellow = {0xff, 0xff, 0x00};
    W_Color W_Cyan = {0x00, 0xff, 0xff};
    W_Color W_Grey = {0xc0, 0xc0, 0xc0};
    W_Color W_DarkGrey = {0x80, 0x80, 0x80};
#else
    extern W_Color W_White;
    extern W_Color W_Black;
    extern W_Color W_Red;
    extern W_Color W_Green;
    extern W_Color W_Yellow;
    extern W_Color W_Cyan;
    extern W_Color W_Grey;
    extern W_Color W_DarkGrey;
#endif


void	W_Initialize();
void	W_CacheClearArea(W_Window window, int x, int y, int width, int height);
void	W_ClearArea(W_Window window, int x, int y, unsigned int width, unsigned int height);
void	W_ClearWindow(W_Window window);
void	W_DisplayBuffer(W_Window window);
void	W_DrawImage(W_Window window, int x, int y, int frame, W_Image *image, W_Color color);
void	W_DrawPoint(W_Window window, int x, int y, W_Color color);
int	W_EventsPending(W_Window window);
void	W_Flush(W_Window window);
void	W_FlushClearAreaCache(W_Window window);
void	W_GetMouse(W_Window window, int *x, int *y, int *but);
void	W_GrabPointer(W_Window window);
int	W_LoadImage(W_Image *image);
void	W_MakeLine(W_Window window, int X0, int Y0, int X1, int Y1, W_Color color);
void	W_MaskText(W_Window window, int x, int y, W_Color color, char *str, int len, W_Font font);
void	W_NextEvent(W_Window window, W_Event *wevent);
int	W_StringWidth(char *string, W_Font font);
void	W_UngrabPointer(W_Window window);

void	beos_obscure_cursor();
void	beos_cycle_color(W_Color *color);
void	beos_free_image(W_Image *image);
void	beos_free_fonts();

#ifdef __cplusplus
}
#endif

#endif // __BEOSSPRITE_H__

